import React,{ useState ,useEffect} from 'react'
import {
  Checkbox, 
  Row, 
  Col
} from 'antd';
import styles from './ListCardItem.less'

const CheckGroup = Checkbox.Group;

const ListCardItem = (props) =>{
  console.log(props)
  const [ indeterminate, setIndeterminate ] = useState(false) 
  const [ allChecked, setAllChecked ] = useState(false) //全选状态
  const [ checkList, setCheckList] = useState([]) //复选框列表
  const { getValueCallback, itemid, userList, OUName } = props
  const defaultList = userList && userList.map( (item,index) =>{
    item.label = item.userName || item.label 
    item.value = item.userID || item.label 
    return item
  }) || []

  const handleAllChecked = (e) =>{
    const { checked } = e.target
    setAllChecked(checked)
    let arr = []
    if(checked){
      arr =  defaultList.map(item =>{
        return item.value
      })
    }else{
      arr = []
    }
    setCheckList(arr)
    setIndeterminate(false)
    getValueCallback(arr,itemid)
  }
  const handleChecked = (e) =>{
    setCheckList(e) ;
    setAllChecked(e.length === defaultList.length)
    setIndeterminate(!!e.length && e.length <defaultList.length)
    getValueCallback(e,itemid)
  }
  return (
    <>
      <div className ={`${styles.divBox}`}>
        <div  className={ styles.topCheckbox}>
          <Checkbox
          indeterminate = { indeterminate}
          checked={ allChecked}
          onChange= { (e) =>{ handleAllChecked(e)}}
          >{OUName}</Checkbox>
        </div>
        <div style={{width:"100%"}} className = {styles.checkdiv}>
         {defaultList && defaultList.length>0 &&  <CheckGroup className = {styles.check} onChange = {(e) => { handleChecked(e)}} value={checkList} options = {defaultList} /> }
        </div>
      </div>
    </>
  )
}

export default ListCardItem